## valkey 8.1.4+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Must be done first
if (APPLE)
    # Force clang compiler on macOS
    find_program(CLANGPP "clang++")
    find_program(CLANG "clang")
    if (CLANG AND CLANGPP)
        message(STATUS "Found ${CLANGPP}, ${CLANG}")
        set(CMAKE_CXX_COMPILER ${CLANGPP})
        set(CMAKE_C_COMPILER ${CLANG})
    endif ()
endif ()

# Options
option(BUILD_UNIT_TESTS "Build valkey-unit-tests" OFF)
option(BUILD_TEST_MODULES "Build all test modules" OFF)
option(BUILD_EXAMPLE_MODULES "Build example modules" OFF)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
project("valkey")

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS ON)

include(ValkeySetup)
add_subdirectory(src)
add_subdirectory(tests)

# Include the packaging module
include(Packaging)

# Clear cached variables from the cache
unset(BUILD_TESTS CACHE)
unset(CLANGPP CACHE)
unset(CLANG CACHE)
unset(BUILD_RDMA_MODULE CACHE)
unset(BUILD_TLS_MODULE CACHE)
unset(BUILD_UNIT_TESTS CACHE)
unset(BUILD_TEST_MODULES CACHE)
unset(BUILD_EXAMPLE_MODULES CACHE)
unset(USE_TLS CACHE)
unset(DEBUG_FORCE_DEFRAG CACHE)

=== deps/CMakeLists.txt ===
if (USE_JEMALLOC)
    add_subdirectory(jemalloc)
endif ()
add_subdirectory(lua)

# Set hiredis options. We need to disable the defaults set in the OPTION(..) we do this by setting them in the CACHE
set(BUILD_SHARED_LIBS
    OFF
    CACHE BOOL "Build shared libraries")
set(DISABLE_TESTS
    ON
    CACHE BOOL "If tests should be compiled or not")
if (USE_TLS) # Module or no module
    message(STATUS "Building hiredis_ssl")
    set(ENABLE_SSL
        ON
        CACHE BOOL "Should we test SSL connections")
endif ()

add_subdirectory(hiredis)
add_subdirectory(linenoise)
add_subdirectory(fpconv)
add_subdirectory(hdr_histogram)

# Clear any cached variables passed to hiredis from the cache
unset(BUILD_SHARED_LIBS CACHE)
unset(DISABLE_TESTS CACHE)
unset(ENABLE_SSL CACHE)

=== deps/Makefile ===
# Dependency Makefile

uname_S:= $(shell sh -c 'uname -s 2>/dev/null || echo not')

LUA_DEBUG?=no
LUA_COVERAGE?=no

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

default:
	@echo "Explicit target required"

.PHONY: default

# Prerequisites target
.make-prerequisites:
	@touch $@

# Clean everything when CFLAGS is different
ifneq ($(shell sh -c '[ -f .make-cflags ] && cat .make-cflags || echo none'), $(CFLAGS))
.make-cflags: distclean
	-(echo "$(CFLAGS)" > .make-cflags)
.make-prerequisites: .make-cflags
endif

# Clean everything when LDFLAGS is different
ifneq ($(shell sh -c '[ -f .make-ldflags ] && cat .make-ldflags || echo none'), $(LDFLAGS))
.make-ldflags: distclean
	-(echo "$(LDFLAGS)" > .make-ldflags)
.make-prerequisites: .make-ldflags
endif

distclean:
	-(cd hiredis && $(MAKE) clean) > /dev/null || true
	-(cd linenoise && $(MAKE) clean) > /dev/null || true
	-(cd lua && $(MAKE) clean) > /dev/null || true
	-(cd jemalloc && [ -f Makefile ] && $(MAKE) distclean) > /dev/null || true
	-(cd hdr_histogram && $(MAKE) clean) > /dev/null || true
	-(cd fpconv && $(MAKE) clean) > /dev/null || true
	-(cd fast_float_c_interface && $(MAKE) clean) > /dev/null || true
	-(rm -f .make-*)

.PHONY: distclean

ifneq (,$(filter $(BUILD_TLS),yes module))
    HIREDIS_MAKE_FLAGS = USE_SSL=1
endif

hiredis: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd hiredis && $(MAKE) static $(HIREDIS_MAKE_FLAGS)

.PHONY: hiredis

linenoise: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd linenoise && $(MAKE)

.PHONY: linenoise

hdr_histogram: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd hdr_histogram && $(MAKE)

.PHONY: hdr_histogram

fpconv: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd fpconv && $(MAKE)

.PHONY: fpconv

ifeq ($(uname_S),SunOS)
	# Make isinf() available
	LUA_CFLAGS= -D__C99FEATURES__=1
endif

LUA_CFLAGS+= -Wall -DLUA_ANSI -DENABLE_CJSON_GLOBAL -DLUA_USE_MKSTEMP $(CFLAGS)
LUA_LDFLAGS+= $(LDFLAGS)
ifeq ($(LUA_DEBUG),yes)
	LUA_CFLAGS+= -O0 -g -DLUA_USE_APICHECK
else
	LUA_CFLAGS+= -O2 
endif
ifeq ($(LUA_COVERAGE),yes)
	LUA_CFLAGS += -fprofile-arcs -ftest-coverage
	LUA_LDFLAGS += -fprofile-arcs -ftest-coverage
endif

# lua's Makefile defines AR="ar rcu", which is unusual, and makes it more
# challenging to cross-compile lua (and redis).  These defines make it easier
# to fit redis into cross-compilation environments, which typically set AR.
AR=ar
ARFLAGS=rc

lua: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd lua/src && $(MAKE) all CFLAGS="$(LUA_CFLAGS)" MYLDFLAGS="$(LUA_LDFLAGS)" AR="$(AR) $(ARFLAGS)"

.PHONY: lua

JEMALLOC_CFLAGS=$(CFLAGS)
JEMALLOC_LDFLAGS=$(LDFLAGS)

ifneq ($(DEB_HOST_GNU_TYPE),)
JEMALLOC_CONFIGURE_OPTS += --host=$(DEB_HOST_GNU_TYPE)
endif

jemalloc: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd jemalloc && ./configure --disable-cxx --with-version=5.3.0-0-g0 --with-lg-quantum=3 --disable-cache-oblivious --with-jemalloc-prefix=je_ CFLAGS="$(JEMALLOC_CFLAGS)" LDFLAGS="$(JEMALLOC_LDFLAGS)" $(JEMALLOC_CONFIGURE_OPTS)
	cd jemalloc && $(MAKE) lib/libjemalloc.a

.PHONY: jemalloc

fast_float_c_interface: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd fast_float_c_interface && $(MAKE)

.PHONY: fast_float_c_interface

=== src/CMakeLists.txt ===
project(valkey-server)

set(INSTALL_BIN_PATH ${CMAKE_INSTALL_PREFIX}/bin)
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

# Target: valkey-server
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${VALKEY_SERVER_CFLAGS}")
message(STATUS "CFLAGS: ${CMAKE_C_FLAGS}")

get_valkey_server_linker_option(VALKEY_SERVER_LDFLAGS)
list(APPEND SERVER_LIBS "fpconv")
list(APPEND SERVER_LIBS "lualib")
list(APPEND SERVER_LIBS "hdr_histogram")
valkey_build_and_install_bin(valkey-server "${VALKEY_SERVER_SRCS}" "${VALKEY_SERVER_LDFLAGS}" "${SERVER_LIBS}"
                             "redis-server")
add_dependencies(valkey-server generate_commands_def)
add_dependencies(valkey-server generate_fmtargs_h)
add_dependencies(valkey-server release_header)

if (VALKEY_RELEASE_BUILD)
    # Enable LTO for Release build
    set_property(TARGET valkey-server PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
endif ()

if (DEBUG_FORCE_DEFRAG)
    message(STATUS "Forcing Active Defrag run on valkey-server")
    target_compile_definitions(valkey-server PRIVATE DEBUG_FORCE_DEFRAG)
    target_compile_definitions(valkey-server PRIVATE HAVE_DEFRAG)
endif ()

if (BUILD_SANITIZER)
    # 'BUILD_SANITIZER' is defined in ValkeySetup module (based on user input)
    # If defined, the variables 'VALKEY_SANITAIZER_CFLAGS' and 'VALKEY_SANITAIZER_LDFLAGS'
    # are set with the link & compile flags required
    message(STATUS "Adding sanitizer flags for target valkey-server")
    target_compile_options(valkey-server PRIVATE ${VALKEY_SANITAIZER_CFLAGS})
    target_link_options(valkey-server PRIVATE ${VALKEY_SANITAIZER_LDFLAGS})
endif ()
unset(BUILD_SANITIZER CACHE)

# Target: valkey-cli
list(APPEND CLI_LIBS "linenoise")
valkey_build_and_install_bin(valkey-cli "${VALKEY_CLI_SRCS}" "${VALKEY_SERVER_LDFLAGS}" "${CLI_LIBS}" "redis-cli")
add_dependencies(valkey-cli generate_commands_def)
add_dependencies(valkey-cli generate_fmtargs_h)

# Target: valkey-benchmark
list(APPEND BENCH_LIBS "hdr_histogram")
valkey_build_and_install_bin(valkey-benchmark "${VALKEY_BENCHMARK_SRCS}" "${VALKEY_SERVER_LDFLAGS}" "${BENCH_LIBS}"
                             "redis-benchmark")
add_dependencies(valkey-benchmark generate_commands_def)
add_dependencies(valkey-benchmark generate_fmtargs_h)

# Targets: valkey-sentinel, valkey-check-aof and valkey-check-rdb are just symbolic links
valkey_create_symlink("valkey-server" "valkey-sentinel")
valkey_create_symlink("valkey-server" "valkey-check-rdb")
valkey_create_symlink("valkey-server" "valkey-check-aof")

# Target valkey-rdma
if (BUILD_RDMA_MODULE)
    set(MODULE_NAME "valkey-rdma")
    message(STATUS "Building RDMA module")
    add_library(${MODULE_NAME} SHARED "${VALKEY_RDMA_MODULE_SRCS}")
    target_compile_options(${MODULE_NAME} PRIVATE -DBUILD_RDMA_MODULE=2 -DUSE_RDMA=1)
    target_link_libraries(${MODULE_NAME} "${RDMA_LIBS}")
    # remove the "lib" prefix from the module
    set_target_properties(${MODULE_NAME} PROPERTIES PREFIX "")
    valkey_install_bin(${MODULE_NAME})
endif ()

# Target valkey-tls (a module)
if (BUILD_TLS_MODULE)
    message(STATUS "Building TLS as a module")
    set(MODULE_NAME "valkey-tls")
    add_library(${MODULE_NAME} SHARED ${VALKEY_TLS_MODULE_SRCS})
    target_compile_options(${MODULE_NAME} PRIVATE -DUSE_OPENSSL=2 -DBUILD_TLS_MODULE=2)
    if (APPLE)
        # Some symbols can only be resolved during runtime (they exist in the executable)
        target_link_options(${MODULE_NAME} PRIVATE -undefined dynamic_lookup)
    endif ()
    target_link_libraries(${MODULE_NAME} hiredis_ssl OpenSSL::SSL)
    set_target_properties(${MODULE_NAME} PROPERTIES PREFIX "")
endif ()

if (BUILD_EXAMPLE_MODULES)
    # Include the modules ("hello*")
    message(STATUS "Building example modules")
    add_subdirectory(modules)
endif ()

if (BUILD_UNIT_TESTS)
    add_subdirectory(unit)
endif ()

=== src/Makefile ===
# Valkey Makefile
# Copyright (C) 2009 Redis Ltd.
# This file is released under the BSD license, see the COPYING file
#
# The Makefile composes the final FINAL_CFLAGS and FINAL_LDFLAGS using
# what is needed for Valkey plus the standard CFLAGS and LDFLAGS passed.
# However when building the dependencies (Jemalloc, Lua, Hiredis, ...)
# CFLAGS and LDFLAGS are propagated to the dependencies, so to pass
# flags only to be used when compiling / linking Valkey itself SERVER_CFLAGS
# and SERVER_LDFLAGS are used instead (this is the case of 'make gcov').
#
# Dependencies are stored in the Makefile.dep file. To rebuild this file
# Just use 'make dep', but this is only needed by developers.

release_hdr := $(shell sh -c './mkreleasehdr.sh')
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')
CLANG := $(findstring clang,$(shell sh -c '$(CC) --version | head -1'))

# Optimization flags. To override, the OPTIMIZATION variable can be passed, but
# some automatic defaults are added to it. To specify optimization flags
# explicitly without any defaults added, pass the OPT variable instead.
OPTIMIZATION?=-O3
ifeq ($(OPTIMIZATION),-O3)
	ifeq (clang,$(CLANG))
		OPTIMIZATION+=-flto
	else
		OPTIMIZATION+=-flto=auto -ffat-lto-objects
	endif
endif
ifneq ($(OPTIMIZATION),-O0)
	OPTIMIZATION+=-fno-omit-frame-pointer
endif
DEPENDENCY_TARGETS=hiredis linenoise lua hdr_histogram fpconv
NODEPS:=clean distclean

# Default settings
STD=-pedantic

# Use -Wno-c11-extensions on clang, either where explicitly used or on
# platforms we can assume it's being used.
ifeq (clang,$(CLANG))
  STD+=-Wno-c11-extensions
else
ifneq (,$(findstring FreeBSD,$(uname_S)))
  STD+=-Wno-c11-extensions
endif
endif
WARN=-Wall -W -Wno-missing-field-initializers -Werror=deprecated-declarations -Wstrict-prototypes
OPT=$(OPTIMIZATION)

# Detect if the compiler supports C11 _Atomic.
# NUMBER_SIGN_CHAR is a workaround to support both GNU Make 4.3 and older versions.
NUMBER_SIGN_CHAR := \#
C11_ATOMIC := $(shell sh -c 'echo "$(NUMBER_SIGN_CHAR)include <stdatomic.h>" > foo.c; \
	$(CC) -std=gnu11 -c foo.c -o foo.o > /dev/null 2>&1; \
	if [ -f foo.o ]; then echo "yes"; rm foo.o; fi; rm foo.c')
ifeq ($(C11_ATOMIC),yes)
	STD+=-std=gnu11
else
	STD+=-std=c99
endif

PREFIX?=/usr/local
INSTALL_BIN=$(PREFIX)/bin
INSTALL=install
PKG_CONFIG?=pkg-config

ifndef PYTHON
PYTHON := $(shell which python3 || which python)
endif

# Default allocator defaults to Jemalloc on Linux and libc otherwise
MALLOC=libc
ifeq ($(uname_S),Linux)
	MALLOC=jemalloc
endif

# To get ARM stack traces if Valkey crashes we need a special C flag.
ifneq (,$(filter aarch64 armv%,$(uname_M)))
        CFLAGS+=-funwind-tables
endif

# Backwards compatibility for selecting an allocator
ifeq ($(USE_TCMALLOC),yes)
	MALLOC=tcmalloc
endif

ifeq ($(USE_TCMALLOC_MINIMAL),yes)
	MALLOC=tcmalloc_minimal
endif

ifeq ($(USE_JEMALLOC),yes)
	MALLOC=jemalloc
endif

ifeq ($(USE_JEMALLOC),no)
	MALLOC=libc
endif

ifdef SANITIZER
ifeq ($(SANITIZER),address)
	MALLOC=libc
	CFLAGS+=-fsanitize=address -fno-sanitize-recover=all -fno-omit-frame-pointer
	LDFLAGS+=-fsanitize=address
else
ifeq ($(SANITIZER),undefined)
	MALLOC=libc
	CFLAGS+=-fsanitize=undefined -fno-sanitize-recover=all -fno-omit-frame-pointer
	LDFLAGS+=-fsanitize=undefined
else
ifeq ($(SANITIZER),thread)
	CFLAGS+=-fsanitize=thread -fno-sanitize-recover=all -fno-omit-frame-pointer
	LDFLAGS+=-fsanitize=thread
else
    $(error "unknown sanitizer=${SANITIZER}")
endif
endif
endif
endif

# Override default settings if possible
-include .make-settings

# For added compatibility REDIS_CFLAGS and REDIS_LDFLAGS are also supported.
ifdef REDIS_CFLAGS
    SERVER_CFLAGS := $(REDIS_CFLAGS)
endif
ifdef REDIS_LDFLAGS
    SERVER_LDFLAGS := $(REDIS_LDFLAGS)
endif

# Special case of forcing defrag to run even though we have no Jemlloc support
ifeq ($(DEBUG_FORCE_DEFRAG), yes)
	SERVER_CFLAGS +=-DHAVE_DEFRAG -DDEBUG_FORCE_DEFRAG
endif

FINAL_CFLAGS=$(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(SERVER_CFLAGS)
FINAL_LDFLAGS=$(LDFLAGS) $(OPT) $(SERVER_LDFLAGS) $(DEBUG)
FINAL_LIBS=-lm
DEBUG=-g -ggdb

# Linux ARM32 needs -latomic at linking time
ifneq (,$(findstring armv,$(uname_M)))
        FINAL_LIBS+=-latomic
else
# Linux POWER needs -latomic at linking time
ifneq (,$(findstring ppc,$(uname_M)))
        FINAL_LIBS+=-latomic
endif
endif

ifeq ($(uname_S),SunOS)
	# SunOS
	ifeq ($(findstring -m32,$(FINAL_CFLAGS)),)
		CFLAGS+=-m64
	endif
	ifeq ($(findstring -m32,$(FINAL_LDFLAGS)),)
		LDFLAGS+=-m64
	endif
	DEBUG=-g
	DEBUG_FLAGS=-g
	export CFLAGS LDFLAGS DEBUG DEBUG_FLAGS
	INSTALL=cp -pf
	FINAL_CFLAGS+= -D__EXTENSIONS__ -D_XPG6
	FINAL_LIBS+= -ldl -lnsl -lsocket -lresolv -lpthread -lrt
	ifeq ($(USE_BACKTRACE),yes)
	    FINAL_CFLAGS+= -DUSE_BACKTRACE
	endif
else
ifeq ($(uname_S),Darwin)
	# Darwin
	FINAL_LIBS+= -ldl
	# Homebrew's OpenSSL is not linked to /usr/local to avoid
	# conflicts with the system's LibreSSL installation so it
	# must be referenced explicitly during build.
ifeq ($(uname_M),arm64)
	# Homebrew arm64 uses /opt/homebrew as HOMEBREW_PREFIX
	OPENSSL_PREFIX?=/opt/homebrew/opt/openssl
else
	# Homebrew x86/ppc uses /usr/local as HOMEBREW_PREFIX
	OPENSSL_PREFIX?=/usr/local/opt/openssl
endif
else
ifeq ($(uname_S),AIX)
        # AIX
        FINAL_LDFLAGS+= -Wl,-bexpall
        FINAL_LIBS+=-ldl -pthread -lcrypt -lbsd
else
ifeq ($(uname_S),OpenBSD)
	# OpenBSD
	FINAL_LIBS+= -lpthread
	ifeq ($(USE_BACKTRACE),yes)
	    FINAL_CFLAGS+= -DUSE_BACKTRACE -I/usr/local/include
	    FINAL_LDFLAGS+= -L/usr/local/lib
	    FINAL_LIBS+= -lexecinfo
    	endif

else
ifeq ($(uname_S),NetBSD)
	# NetBSD
	FINAL_LIBS+= -lpthread
	ifeq ($(USE_BACKTRACE),yes)
	    FINAL_CFLAGS+= -DUSE_BACKTRACE -I/usr/pkg/include
	    FINAL_LDFLAGS+= -L/usr/pkg/lib
	    FINAL_LIBS+= -lexecinfo
    	endif
else
ifeq ($(uname_S),FreeBSD)
	# FreeBSD
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),DragonFly)
	# DragonFly
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),OpenBSD)
	# OpenBSD
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),NetBSD)
	# NetBSD
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),Haiku)
	# Haiku
	FINAL_CFLAGS+= -DBSD_SOURCE
	FINAL_LDFLAGS+= -lbsd -lnetwork
	FINAL_LIBS+= -lpthread
else
	# All the other OSes (notably Linux)
	FINAL_LDFLAGS+= -rdynamic
	FINAL_LIBS+=-ldl -pthread -lrt
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif

ifdef OPENSSL_PREFIX
	OPENSSL_CFLAGS=-I$(OPENSSL_PREFIX)/include
	OPENSSL_LDFLAGS=-L$(OPENSSL_PREFIX)/lib
	# Also export OPENSSL_PREFIX so it ends up in deps sub-Makefiles
	export OPENSSL_PREFIX
endif

# Include paths to dependencies
FINAL_CFLAGS+= -I../deps/hiredis -I../deps/linenoise -I../deps/lua/src -I../deps/hdr_histogram -I../deps/fpconv

# Determine systemd support and/or build preference (defaulting to auto-detection)
BUILD_WITH_SYSTEMD=no
LIBSYSTEMD_LIBS=-lsystemd

# If 'USE_SYSTEMD' in the environment is neither "no" nor "yes", try to
# auto-detect libsystemd's presence and link accordingly.
ifneq ($(USE_SYSTEMD),no)
	LIBSYSTEMD_PKGCONFIG := $(shell $(PKG_CONFIG) --exists libsystemd && echo $$?)
# If libsystemd cannot be detected, continue building without support for it
# (unless a later check tells us otherwise)
ifeq ($(LIBSYSTEMD_PKGCONFIG),0)
	BUILD_WITH_SYSTEMD=yes
	LIBSYSTEMD_LIBS=$(shell $(PKG_CONFIG) --libs libsystemd)
endif
endif

# If 'USE_SYSTEMD' is set to "yes" use pkg-config if available or fall back to
# default -lsystemd.
ifeq ($(USE_SYSTEMD),yes)
	BUILD_WITH_SYSTEMD=yes
endif

ifeq ($(BUILD_WITH_SYSTEMD),yes)
	FINAL_LIBS+=$(LIBSYSTEMD_LIBS)
	FINAL_CFLAGS+= -DHAVE_LIBSYSTEMD
endif

ifeq ($(MALLOC),tcmalloc)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc
endif

ifeq ($(MALLOC),tcmalloc_minimal)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc_minimal
endif

ifeq ($(MALLOC),jemalloc)
	DEPENDENCY_TARGETS+= jemalloc
	FINAL_CFLAGS+= -DUSE_JEMALLOC -I../deps/jemalloc/include
	FINAL_LIBS := ../deps/jemalloc/lib/libjemalloc.a $(FINAL_LIBS)
endif

# LIBSSL & LIBCRYPTO
LIBSSL_LIBS=
LIBSSL_PKGCONFIG := $(shell $(PKG_CONFIG) --exists libssl && echo $$?)
ifeq ($(LIBSSL_PKGCONFIG),0)
	LIBSSL_LIBS=$(shell $(PKG_CONFIG) --libs libssl)
else
	LIBSSL_LIBS=-lssl
endif
LIBCRYPTO_LIBS=
LIBCRYPTO_PKGCONFIG := $(shell $(PKG_CONFIG) --exists libcrypto && echo $$?)
ifeq ($(LIBCRYPTO_PKGCONFIG),0)
	LIBCRYPTO_LIBS=$(shell $(PKG_CONFIG) --libs libcrypto)
else
	LIBCRYPTO_LIBS=-lcrypto
endif

BUILD_NO:=0
BUILD_YES:=1
BUILD_MODULE:=2
ifeq ($(BUILD_TLS),yes)
	FINAL_CFLAGS+=-DUSE_OPENSSL=$(BUILD_YES) $(OPENSSL_CFLAGS) -DBUILD_TLS_MODULE=$(BUILD_NO)
	FINAL_LDFLAGS+=$(OPENSSL_LDFLAGS)
	FINAL_LIBS += ../deps/hiredis/libhiredis_ssl.a $(LIBSSL_LIBS) $(LIBCRYPTO_LIBS)
endif

TLS_MODULE=
TLS_MODULE_NAME:=valkey-tls$(PROG_SUFFIX).so
TLS_MODULE_CFLAGS:=$(FINAL_CFLAGS)
ifeq ($(BUILD_TLS),module)
	FINAL_CFLAGS+=-DUSE_OPENSSL=$(BUILD_MODULE) $(OPENSSL_CFLAGS)
	TLS_CLIENT_LIBS = ../deps/hiredis/libhiredis_ssl.a $(LIBSSL_LIBS) $(LIBCRYPTO_LIBS)
	TLS_MODULE=$(TLS_MODULE_NAME)
	TLS_MODULE_CFLAGS+=-DUSE_OPENSSL=$(BUILD_MODULE) $(OPENSSL_CFLAGS) -DBUILD_TLS_MODULE=$(BUILD_MODULE)
endif

RDMA_LIBS=
RDMA_PKGCONFIG := $(shell $(PKG_CONFIG) --exists librdmacm libibverbs && echo $$?)
ifeq ($(RDMA_PKGCONFIG),0)
	RDMA_LIBS=$(shell $(PKG_CONFIG) --libs librdmacm libibverbs)
else
	RDMA_LIBS=-lrdmacm -libverbs
endif

ifeq ($(BUILD_RDMA),yes)
	FINAL_CFLAGS+=-DUSE_RDMA=$(BUILD_YES) -DBUILD_RDMA_MODULE=$(BUILD_NO)
	FINAL_LIBS += $(RDMA_LIBS)
endif

RDMA_MODULE=
RDMA_MODULE_NAME:=valkey-rdma$(PROG_SUFFIX).so
RDMA_MODULE_CFLAGS:=$(FINAL_CFLAGS)
ifeq ($(BUILD_RDMA),module)
	FINAL_CFLAGS+=-DUSE_RDMA=$(BUILD_MODULE)
	RDMA_MODULE=$(RDMA_MODULE_NAME)
	RDMA_MODULE_CFLAGS+=-DUSE_RDMA=$(BUILD_MODULE) -DBUILD_RDMA_MODULE=$(BUILD_MODULE) $(RDMA_LIBS)
endif

ifndef V
    define MAKE_INSTALL
        @printf '    %b %b\n' $(LINKCOLOR)INSTALL$(ENDCOLOR) $(BINCOLOR)$(1)$(ENDCOLOR) 1>&2
        @$(INSTALL) $(1) $(2)
    endef

    define INSTALL_REDIS_SYMLINK
        @printf '    %b %b %b %b %b %b %b\n' \
        $(LINKCOLOR)INSTALL SYMLINK$(ENDCOLOR) \
        $(BINCOLOR)$(subst $(ENGINE_NAME),redis,$(1))$(ENDCOLOR) -\> $(BINCOLOR)$(1)$(ENDCOLOR) 1>&2
        @ln -sf $(1) $(2)/$(subst $(ENGINE_NAME),redis,$(1))
    endef
else
    define MAKE_INSTALL
        $(INSTALL) $(1) $(2)
    endef

    define INSTALL_REDIS_SYMLINK
        ln -sf $(1) $(2)/$(subst $(ENGINE_NAME),redis,$(1))
    endef
endif

# Determine install/uninstall Redis symlinks for compatibility when
# installing/uninstalling Valkey binaries (defaulting to `yes`)
USE_REDIS_SYMLINKS?=yes
ifeq ($(USE_REDIS_SYMLINKS),yes)
	MAYBE_INSTALL_REDIS_SYMLINK=$(INSTALL_REDIS_SYMLINK)
	MAYBE_UNINSTALL_REDIS_SYMLINK=@rm -f $(1)/$(subst $(ENGINE_NAME),redis,$(2))
else
	MAYBE_INSTALL_REDIS_SYMLINK=
	MAYBE_UNINSTALL_REDIS_SYMLINK=
endif

SERVER_CC=$(QUIET_CC)$(CC) $(FINAL_CFLAGS)
SERVER_AR=$(QUIET_AR)$(AR)
SERVER_LD=$(QUIET_LINK)$(CC) $(FINAL_LDFLAGS)
ENGINE_INSTALL=$(QUIET_INSTALL)$(INSTALL)

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

ifndef V
QUIET_CC = @printf '    %b %b\n' $(CCCOLOR)CC$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_GEN = @printf '    %b %b\n' $(CCCOLOR)GEN$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_LINK = @printf '    %b %b\n' $(LINKCOLOR)LINK$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_INSTALL = @printf '    %b %b\n' $(LINKCOLOR)INSTALL$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_AR = @printf '    %b %b\n' $(CCCOLOR)ARCHIVE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
endif

ifneq (, $(findstring LOG_REQ_RES, $(SERVER_CFLAGS)))
	COMMANDS_DEF_FILENAME=commands_with_reply_schema
	GEN_COMMANDS_FLAGS=--with-reply-schema
else
	COMMANDS_DEF_FILENAME=commands
	GEN_COMMANDS_FLAGS=
endif

ENGINE_NAME=valkey
SERVER_NAME=$(ENGINE_NAME)-server$(PROG_SUFFIX)
ENGINE_SENTINEL_NAME=$(ENGINE_NAME)-sentinel$(PROG_SUFFIX)

=== tests/CMakeLists.txt ===
add_subdirectory(rdma)

if (BUILD_TEST_MODULES)
    add_subdirectory(modules)
endif ()

=== deps/hdr_histogram/CMakeLists.txt ===
project(hdr_histogram)

set(SRCS "${CMAKE_CURRENT_LIST_DIR}/hdr_histogram.c" "${CMAKE_CURRENT_LIST_DIR}/hdr_histogram.h"
         "${CMAKE_CURRENT_LIST_DIR}/hdr_atomic.h" "${CMAKE_CURRENT_LIST_DIR}/hdr_redis_malloc.h")

add_library(hdr_histogram STATIC ${SRCS})
target_compile_definitions(hdr_histogram PRIVATE HDR_MALLOC_INCLUDE=\"hdr_redis_malloc.h\")

=== deps/hdr_histogram/Makefile ===
STD= -std=c99
WARN= -Wall
OPT= -Os

R_CFLAGS= $(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) -DHDR_MALLOC_INCLUDE=\"hdr_redis_malloc.h\"
R_LDFLAGS= $(LDFLAGS)
DEBUG= -g

R_CC=$(CC) $(R_CFLAGS)
R_LD=$(CC) $(R_LDFLAGS)

AR= ar
ARFLAGS= rcs

libhdrhistogram.a: hdr_histogram.o
	$(AR) $(ARFLAGS) $@ $+

hdr_histogram.o: hdr_histogram.h hdr_histogram.c

.c.o:
	$(R_CC) -c  $< 

clean:
	rm -f *.o
	rm -f *.a

=== deps/lua/CMakeLists.txt ===
project(lualib)

include(CheckFunctionExists)

set(LUA_SRC_DIR "${CMAKE_CURRENT_LIST_DIR}/src")
set(LUA_SRCS
    ${LUA_SRC_DIR}/fpconv.c
    ${LUA_SRC_DIR}/lbaselib.c
    ${LUA_SRC_DIR}/lmathlib.c
    ${LUA_SRC_DIR}/lstring.c
    ${LUA_SRC_DIR}/lparser.c
    ${LUA_SRC_DIR}/ldo.c
    ${LUA_SRC_DIR}/lzio.c
    ${LUA_SRC_DIR}/lmem.c
    ${LUA_SRC_DIR}/strbuf.c
    ${LUA_SRC_DIR}/lstrlib.c
    ${LUA_SRC_DIR}/lundump.c
    ${LUA_SRC_DIR}/lua_cmsgpack.c
    ${LUA_SRC_DIR}/loslib.c
    ${LUA_SRC_DIR}/lua_struct.c
    ${LUA_SRC_DIR}/ldebug.c
    ${LUA_SRC_DIR}/lobject.c
    ${LUA_SRC_DIR}/ldump.c
    ${LUA_SRC_DIR}/lua_cjson.c
    ${LUA_SRC_DIR}/ldblib.c
    ${LUA_SRC_DIR}/ltm.c
    ${LUA_SRC_DIR}/ltable.c
    ${LUA_SRC_DIR}/lstate.c
    ${LUA_SRC_DIR}/lua_bit.c
    ${LUA_SRC_DIR}/lua.c
    ${LUA_SRC_DIR}/loadlib.c
    ${LUA_SRC_DIR}/lcode.c
    ${LUA_SRC_DIR}/lapi.c
    ${LUA_SRC_DIR}/lgc.c
    ${LUA_SRC_DIR}/lvm.c
    ${LUA_SRC_DIR}/lfunc.c
    ${LUA_SRC_DIR}/lauxlib.c
    ${LUA_SRC_DIR}/ltablib.c
    ${LUA_SRC_DIR}/linit.c
    ${LUA_SRC_DIR}/lopcodes.c
    ${LUA_SRC_DIR}/llex.c
    ${LUA_SRC_DIR}/liolib.c)

add_library(lualib STATIC "${LUA_SRCS}")
target_include_directories(lualib PUBLIC "${LUA_SRC_DIR}")
target_compile_definitions(lualib PRIVATE ENABLE_CJSON_GLOBAL)

# Use mkstemp if available
check_function_exists(mkstemp HAVE_MKSTEMP)
if (HAVE_MKSTEMP)
    target_compile_definitions(lualib PRIVATE LUA_USE_MKSTEMP)
endif ()
unset(HAVE_MKSTEMP CACHE)

=== tests/modules/CMakeLists.txt ===
# Build test modules
list(APPEND MODULES_LIST "commandfilter")
list(APPEND MODULES_LIST "basics")
list(APPEND MODULES_LIST "testrdb")
list(APPEND MODULES_LIST "fork")
list(APPEND MODULES_LIST "infotest")
list(APPEND MODULES_LIST "propagate")
list(APPEND MODULES_LIST "misc")
list(APPEND MODULES_LIST "hooks")
list(APPEND MODULES_LIST "blockonkeys")
list(APPEND MODULES_LIST "blockonbackground")
list(APPEND MODULES_LIST "scan")
list(APPEND MODULES_LIST "datatype")
list(APPEND MODULES_LIST "datatype2")
list(APPEND MODULES_LIST "auth")
list(APPEND MODULES_LIST "keyspace_events")
list(APPEND MODULES_LIST "blockedclient")
list(APPEND MODULES_LIST "getkeys")
list(APPEND MODULES_LIST "getchannels")
list(APPEND MODULES_LIST "test_lazyfree")
list(APPEND MODULES_LIST "timer")
list(APPEND MODULES_LIST "defragtest")
list(APPEND MODULES_LIST "keyspecs")
list(APPEND MODULES_LIST "hash")
list(APPEND MODULES_LIST "zset")
list(APPEND MODULES_LIST "stream")
list(APPEND MODULES_LIST "mallocsize")
list(APPEND MODULES_LIST "aclcheck")
list(APPEND MODULES_LIST "list")
list(APPEND MODULES_LIST "subcommands")
list(APPEND MODULES_LIST "reply")
list(APPEND MODULES_LIST "cmdintrospection")
list(APPEND MODULES_LIST "eventloop")
list(APPEND MODULES_LIST "moduleconfigs")
list(APPEND MODULES_LIST "moduleconfigstwo")
list(APPEND MODULES_LIST "publish")
list(APPEND MODULES_LIST "usercall")
list(APPEND MODULES_LIST "postnotifications")
list(APPEND MODULES_LIST "moduleauthtwo")
list(APPEND MODULES_LIST "rdbloadsave")
list(APPEND MODULES_LIST "crash")
list(APPEND MODULES_LIST "cluster")
list(APPEND MODULES_LIST "helloscripting")

foreach (MODULE_NAME ${MODULES_LIST})
    message(STATUS "Building test module: ${MODULE_NAME}")
    add_library(${MODULE_NAME} SHARED "${CMAKE_SOURCE_DIR}/tests/modules/${MODULE_NAME}.c")
    target_include_directories(${MODULE_NAME} PRIVATE "${CMAKE_SOURCE_DIR}/src")
    if (LINUX AND NOT APPLE)
        # set the std to gnu11 here, to allow crash.c to get compiled
        target_compile_options(${MODULE_NAME} PRIVATE "-std=gnu11")
    endif ()
    set_target_properties(${MODULE_NAME} PROPERTIES PREFIX "")
    valkey_install_bin(${MODULE_NAME})
    if (APPLE)
        # Some symbols can only be resolved during runtime (they exist in the executable)
        target_link_options(${MODULE_NAME} PRIVATE -undefined dynamic_lookup)
    endif ()
endforeach ()

=== tests/modules/Makefile ===

# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

warning_cflags = -W -Wall -Wno-missing-field-initializers
ifeq ($(uname_S),Darwin)
	SHOBJ_CFLAGS ?= $(warning_cflags) -dynamic -fno-common -g -ggdb -std=gnu11 -O2
	SHOBJ_LDFLAGS ?= -bundle -undefined dynamic_lookup
else	# Linux, others
	SHOBJ_CFLAGS ?= $(warning_cflags) -fno-common -g -ggdb -std=gnu11 -O2
	SHOBJ_LDFLAGS ?= -shared
endif

ifeq ($(uname_S),Linux)
    LD = gcc
    CC = gcc
endif

# OS X 11.x doesn't have /usr/lib/libSystem.dylib and needs an explicit setting.
ifeq ($(uname_S),Darwin)
ifeq ("$(wildcard /usr/lib/libSystem.dylib)","")
LIBS = -L /Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/usr/lib -lsystem
endif
endif

TEST_MODULES = \
    commandfilter.so \
    basics.so \
    testrdb.so \
    fork.so \
    infotest.so \
    propagate.so \
    misc.so \
    hooks.so \
    blockonkeys.so \
    blockonbackground.so \
    scan.so \
    datatype.so \
    datatype2.so \
    auth.so \
    keyspace_events.so \
    block_keyspace_notification.so \
    blockedclient.so \
    getkeys.so \
    getchannels.so \
    test_lazyfree.so \
    timer.so \
    defragtest.so \
    keyspecs.so \
    hash.so \
    zset.so \
    stream.so \
    mallocsize.so \
    aclcheck.so \
    list.so \
    subcommands.so \
    reply.so \
    cmdintrospection.so \
    eventloop.so \
    moduleconfigs.so \
    moduleconfigstwo.so \
    moduleparameter.so \
    publish.so \
    usercall.so \
    postnotifications.so \
    moduleauthtwo.so \
    rdbloadsave.so \
    crash.so \
    cluster.so \
    helloscripting.so

.PHONY: all

all: $(TEST_MODULES)

32bit:
	$(MAKE) CFLAGS="-m32" LDFLAGS="-m32"

%.xo: %.c ../../src/valkeymodule.h
	$(CC) -I../../src $(CFLAGS) $(SHOBJ_CFLAGS) -fPIC -c $< -o $@

%.so: %.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LDFLAGS) $(LIBS)

.PHONY: clean

clean:
	rm -f $(TEST_MODULES) $(TEST_MODULES:.so=.xo)

=== tests/rdma/CMakeLists.txt ===
project(rdma-test)

# Make sure RDMA build is enabled
if (BUILD_RDMA_MODULE)
    add_executable(rdma-test "${CMAKE_SOURCE_DIR}/tests/rdma/rdma-test.c")
    target_link_libraries(rdma-test "${RDMA_LIBS}")
    target_link_options(rdma-test PRIVATE "-pthread")
    valkey_install_bin(rdma-test)
endif ()

=== debian/changelog ===
valkey (8.1.4+dfsg1-0ubuntu1) resolute; urgency=medium

  * New upstream version 8.1.4 (LP: #2127122)
    - Security fixes:
      + CVE-2025-49844: Lua script may lead to remote code execution.
      + CVE-2025-46817: Lua script may lead to int overflow and potential RCE.
      + CVE-2025-46818: Lua script can be executed in context of another user.
      + CVE-2025-46819: LUA out-of-bound read
      + CVE-2025-49112: Integer underflow in setDeferredReply networking.c.
    - Bug fixes:
      + Fix accounting for dual channel RDB bytes in replication stats.
      + Ensure empty error tables in scripts don't crash Valkey.
      + Fix use-after-free when active expiration triggers hashtable to shrink.
      + Fix memory usage to consider embedded keys.
      + Fix leak when shrinking a hashtable without entries.
      + Fix large allocations crashing Valkey during active defrag.
      + Prevent bad memory access when NOTOUCH client gets unblocked.
      + Converge shard-id persisted in nodes.conf to primary's shard id.
      + Fix client tracking memory overhead calculation.
      + Fix pre-size hashtables per slot when reading RDB files.
      + Don't use AVX2 instructions if the CPU don't support it.
      + Defrag if slab 1/8 full to fix defrag didn't stop issue.
  * Remove patches fixed upstream:
    - d/p/CVE-2025-49112.patch
    - d/p/fix-8.1.x-multi-unit-test.patch

 -- Lena Voytek <lena.voytek@canonical.com>  Sun, 12 Oct 2025 15:56:43 -0400

valkey (8.1.3+dfsg1-0ubuntu2) questing; urgency=medium

  * Remove valkey-redis-compat package (LP: #2118952)
    - d/control: Remove valkey-redis-compat entry.
    - Remove valkey-redis-compat package files:
      + d/valkey-redis-compat.postinst
      + d/valkey-redis-compat.links
      + d/valkey-redis-compat.NEWS
    - d/README.Debian: Remove migration readme entry.
    - d/bin/generate-systemd-service-files: Remove condition that blocks
      service start when REDIS_MIGRATION file exists.
    - d/t/0006-migrate-from-redis: Remove redis migration test.
    - d/NEWS: Add news entry to show valkey-redis-compat has been removed.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 12 Aug 2025 16:09:05 -0400

=== debian/control ===
Source: valkey
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Lucas Kanashiro <kanashiro@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libhiredis-dev,
 libjemalloc-dev [linux-any],
 liblua5.1-dev,
 liblzf-dev,
 libssl-dev,
 libsystemd-dev,
 lua-bitop-dev,
 lua-cjson-dev,
 openssl <!nocheck>,
 pkgconf,
 procps <!nocheck>,
 tcl <!nocheck>,
 tcl-tls <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://valkey.io
Vcs-Git: https://salsa.debian.org/debian/valkey.git
Vcs-Browser: https://salsa.debian.org/debian/valkey
Rules-Requires-Root: no

Package: valkey-server
Provides: valkey
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 valkey-tools (= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface
 Valkey is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Valkey additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: valkey-sentinel
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 valkey-tools (= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (monitoring)
 Valkey is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Valkey additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the Valkey Sentinel monitoring software.

Package: valkey-tools
Architecture: any
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ruby-redis,
Description: Persistent key-value database with network interface (client)
 Valkey is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Valkey additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the command line client and other tools.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export BUILD_TLS = yes
export CFLAGS CPPFLAGS LDFLAGS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/liblzf
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-no-as-needed -ldl -latomic -llzf

# Build jemelloc in parallel
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
	export MAKEFLAGS
endif

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/release.h debian/*.service

override_dh_auto_build:
	dh_auto_build -- V=1 USE_SYSTEM_JEMALLOC=yes USE_SYSTEMD=yes USE_JEMALLOC=yes

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Generate a root CA and server certificate for testing
	./utils/gen-test-certs.sh
	# Avoid race conditions in upstream testsuite
	# Skip memefficiency tests as activedefrag is unavailable in system jemalloc
	./runtest --clients 1 --verbose --dump-logs --tls --skipunit unit/memefficiency
	timeout 30m ./runtest-cluster --tls
	./runtest-sentinel
	# Clean up after gen-test-certs.sh
	rm -rf tests/tls || true
	# Other cleanup
	find tests/tmp ! -name .gitignore -type f -exec rm -rfv {} +
endif

override_dh_auto_install:
	debian/bin/generate-systemd-service-files

override_dh_compress:
	dh_compress -Xredis-trib.rb

override_dh_installchangelogs:
	dh_installchangelogs --keep 00-RELEASENOTES

## valkey 8.1.6+dfsg1

=== debian/changelog ===
valkey (8.1.6+dfsg1-0ubuntu0.1) questing; urgency=medium

  * New upstream version 8.1.6 (LP: #2142590)
    - Security fixes:
        + CVE-2025-67733: RESP Protocol Injection via Lua error_reply.
        + CVE-2026-21863: Remote DoS with malformed Valkey Cluster bus message.
    - Bug fixes:
        + Restrict ttl from being negative and avoid crash in import-mode.
        + Fix chained replica crash when doing dual channel replication.
        + Fix used_memory_dataset underflow due to miscalculated
          used_memory_overhead.
        + Fix crashing while MODULE UNLOAD when ACL rules reference a module
          command or subcommand.
        + Fix server assert on ACL LOAD and resetchannels.
        + Fix bug causing no response flush sometimes when IO threads are busy.
        + Fix Lua VM crash after FUNCTION FLUSH ASYNC + FUNCTION LOAD.
        + Fix invalid memory address caused by hashtable shrinking during safe
          iteration.
        + Cluster: Avoid usage of light weight messages to nodes with not ready
          bidirectional links.
        + Send duplicate multi meet packet only for node which supports it.
        + Fix loading AOF files from future Valkey versions.
  * d/rules: Skip maxmemory unit test during builds as it often times out.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 24 Feb 2026 08:49:19 -0500

valkey (8.1.4+dfsg1-0ubuntu0.2) questing-security; urgency=medium

  * No change rebuild to copy previous update to the security pocket.

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Wed, 19 Nov 2025 11:17:22 -0330

valkey (8.1.4+dfsg1-0ubuntu0.1) questing; urgency=medium

  * New upstream version 8.1.4 (LP: #2127122)
    - Security fixes:
      + CVE-2025-49844: Lua script may lead to remote code execution.
      + CVE-2025-46817: Lua script may lead to int overflow and potential RCE.
      + CVE-2025-46818: Lua script can be executed in context of another user.
      + CVE-2025-46819: LUA out-of-bound read
      + CVE-2025-49112: Integer underflow in setDeferredReply networking.c.
    - Bug fixes:
      + Fix accounting for dual channel RDB bytes in replication stats.
      + Ensure empty error tables in scripts don't crash Valkey.
      + Fix use-after-free when active expiration triggers hashtable to shrink.
      + Fix memory usage to consider embedded keys.
      + Fix leak when shrinking a hashtable without entries.
      + Fix large allocations crashing Valkey during active defrag.
      + Prevent bad memory access when NOTOUCH client gets unblocked.
      + Converge shard-id persisted in nodes.conf to primary's shard id.
      + Fix client tracking memory overhead calculation.
      + Fix pre-size hashtables per slot when reading RDB files.
      + Don't use AVX2 instructions if the CPU don't support it.
      + Defrag if slab 1/8 full to fix defrag didn't stop issue.
  * Remove patches fixed upstream:
    - d/p/CVE-2025-49112.patch
    - d/p/fix-8.1.x-multi-unit-test.patch

 -- Lena Voytek <lena.voytek@canonical.com>  Sat, 11 Oct 2025 22:37:19 -0400

=== debian/rules ===
--- 
+++ 
@@ -32,7 +32,8 @@
 	./utils/gen-test-certs.sh
 	# Avoid race conditions in upstream testsuite
 	# Skip memefficiency tests as activedefrag is unavailable in system jemalloc
-	./runtest --clients 1 --verbose --dump-logs --tls --skipunit unit/memefficiency
+	# Skip maxmemory as it often times out on lp builders
+	./runtest --clients 1 --verbose --dump-logs --tls --skipunit unit/memefficiency --skipunit unit/maxmemory
 	timeout 30m ./runtest-cluster --tls
 	./runtest-sentinel
 	# Clean up after gen-test-certs.sh

## valkey 9.0.2

=== debian/changelog ===
valkey (9.0.2-0ubuntu1) resolute; urgency=medium

  * New major upstream version 9.0.2 (LP: #2138972)
    - New features:
      + Add extended filtering for client commands.
      + Add multi-database support to cluster mode.
      + Add BYPOLYGON option for GEOSEARCH.
      + Introduce MPTCP support for primary and replica.
      + Add sentinel_total_tilt to sentinel INFO sentinel.
      + Add support for automatic client authentication via TLS certificate
        fields.
      + Add --hotkeys-count option for valkey-cli.
      + Introduce atomic slot migration.
      + Add DELIFEQ command.
      + Add CLUSTER FLUSHSLOT command.
      + Allow dynamic modification of io-threads num.
      + Introduce HASH items expiration.
      + Add SAFE option to SHUTDOWN to reject shutdown in unsafe situations.
      + Add new cluster-announce-client-(port|tls-port) configs.
      + Implement a lolwut for version 9.
    - Updates:
      + Add node pfail and fail count to cluster info metrics.
      + Introduce support for lttng based tracing.
      + Various performance optimizations including SIMD instructions, pipelining,
        hash tables, replication, and network operations.
      + Trigger manual failover on SIGTERM / shutdown to cluster primary.
      + Add cluster bus port out of range error message for CLUSTER MEET
        command.
      + Add cluster-manual-failover-timeout to configure the timeout for manual
        failover.
      + Allow replicas to become primaries without data by using CLUSTER
        REPLICATE NO ONE.
      + Update reply schema for LMOVE and BLMOVE.
      + Make CONFIG RESETSTATS also reset cluster related stats.
      + Make CONFIG GET command return sorted output.
    - Bug fixes:
      + Fix temp file leak during replication error handling.
      + Fix raxRemove crash at memcpy() due to key size exceeds max Rax size.
      + Fix error "SSL routines::bad length" when connTLSWrite is called second
        time with smaller buffer.
      + Fix cmd's out bytes to count deferred reply.
      + Fix engine crash on module client blocking during keyspace events.
      + Fix invalidation messages being sent to closing clients.
      + Fix ACL LOAD crash on replica since the primary client doesn't have a
        user.
      + Fix RANDOMKEY infinite loop during CLIENT PAUSE.
      + Fix panic in primary when blocking shutdown after previous block with
        timeout.
      + Fix cluster slot stats assertion during promotion of replica.
      + Fix incorrect lag reported in XINFO GROUPS.
      + Fix crash during TLS handshake with I/O threads.
      + Fix random element selection in skewed sparse hash table.
      + Fix memory corruption in sharded pubsub unsubscribe.
      + Fix replica failover issues when config epoch is outdated.
      + Fix CLUSTER SLOTS/NODES showing wrong port after updating port/tls-
        port.
      + Fix missing response when AUTH returns an error inside a transaction.
      + Fix memory leak with CLIENT LIST/KILL duplicate filters.
      + Fix replicas claiming to still have slots after manual failover.
      + Fix module context object re-use in scripting engines.
      + Fix defrag not stopping by defragging when slab 1/8 full.
      + Fix module key memory usage accounting.
      + Fix double MOVED reply on unblock at failover.
      + Fix Lua VM crash after FUNCTION FLUSH ASYNC + FUNCTION LOAD.
      + Fix invalid memory address caused by hashtable shrinking during safe
        iteration.
      + Fix Sentinel regression requiring "+failover" ACL in failover path.
      + Fix LTRIM to not call signalModifiedKey when no elements are removed.
      + Fix build on some 32-bit ARM by only using NEON on AArch64.
      + Fix deadlock in IO-thread shutdown during panic.
      + Fix CLUSTER SLOTS crash when called from module timer callback.
      + Respect process umask when creating data files.
      + Enable TCP_NODELAY by default in incoming and outgoing connections.
      + Ignore stale gossip packets that arrive out of order.
      + Remove unicode optimization in Lua cjson library.
      + Save config file and broadcast PONG message on configEpoch change.
      + Improve clarity of errors for GEO commands when member does not exist.
      + Allow mixing quoted and unquoted inline args.
      + Mark the client reprocessing flag only when unblocked on keys.
      + Prevent CLIENT UNBLOCK from unpausing paused clients.
      + Disallow sending REPLY ON / OFF / SKIP inside a multi-exec transaction.
      + Detect SSL_new() returning NULL in outgoing connections.
      + Correctly handle large cluster bus extensions which may have resulted
        in dropped cluster packets.
      + Avoid shard id update of replica if it doesn't match with primary shard
        id.
      + Redact user data when a module crashes for not handling I/O errors
        enabled.
      + Generate a new shard_id when the replica executes CLUSTER RESET SOFT.
      + Reset io_last_written on c->buf resize to prevent stale pointers.
      + Avoid usage of light weight messages to nodes with not ready
        bidirectional links in cluster.
      + Send duplicate multi meet packet only for node which supports it in
        mixed clusters.
  * d/p/0002-Add-CPPFLAGS-to-upstream-makefiles.patch: Refresh for new version.
  * d/p/0004-Add-support-for-USE_SYSTEM_JEMALLOC-flag.patch: Match check for
    USE_SYSTEM_JEMALLOC to that of USE_JEMALLOC.
  * d/copyright: Update for new version and remove excluded files with fixed
    license.
  * d/rules: Skip maxmemory unit test during builds as it often times out.
  * d/rules: Skip sentinel tests on armhf due to lack of memory.

 -- Lena Voytek <lena.voytek@canonical.com>  Fri, 23 Jan 2026 17:14:04 -0500

## valkey 9.0.3

=== debian/changelog ===
valkey (9.0.3-0ubuntu1) resolute; urgency=medium

  * New upstream version 9.0.3 (LP: #2142590)
    - Security fixes:
        + CVE-2025-67733: RESP Protocol Injection via Lua error_reply.
        + CVE-2026-21863: Remote DoS with malformed Valkey Cluster bus message.
        + CVE-2026-27623: Reset request type after handling empty requests.
    - Bug fixes:
        + Avoid crash during MODULE UNLOAD when ACL rules reference a module
          command and subcommand.
        + Fix server assert on ACL LOAD when current user loses permission to
          channels.
        + Fix bug causing no response flush sometimes when IO threads are busy.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 24 Feb 2026 08:20:13 -0500

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+
+ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
 export BUILD_TLS = yes
 export CFLAGS CPPFLAGS LDFLAGS
@@ -35,7 +37,12 @@
 	# Skip maxmemory as it often times out on lp builders
 	./runtest --clients 1 --verbose --dump-logs --tls --skipunit unit/memefficiency --skipunit unit/maxmemory
 	timeout 30m ./runtest-cluster --tls
+
+	# Skip sentinel tests on armhf due to lack of memory on 32 bit systems
+ifneq ($(ARCH),armhf)
 	./runtest-sentinel
+endif
+
 	# Clean up after gen-test-certs.sh
 	rm -rf tests/tls || true
 	# Other cleanup

## valkey glide-2.1.0rc9

=== requirements.txt ===
# Note: The main location for tracking dependencies is pyproject.toml. This file is used only for the ORT process. When adding a dependency, make sure to add it both to this file and to pyproject.toml. 
# Once issue https://github.com/aboutcode-org/python-inspector/issues/197 is resolved, this file can be removed.
anyio>=4.9.0
typing-extensions>=4.8.0
protobuf>=3.20
